#ifndef cDAG_BINARY_SCHEDULE_TYPES_HPP
#define cDAG_BINARY_SCHEDULE_TYPES_HPP

typedef enum {
	cDAG_BIN_SEND,
	cDAG_BIN_RECV
} cDAG_BinOpType;

typedef struct {
	cDAG_OpType type;
	unsigned int inedges;
	unsigned int outedges;
	void* buf.
	cDAG_MemType memtype,
	unsigned int count,
	unsigned int dest,
	unsigned int outedges[1]
} cDAG_BinSend;

typedef struct {
	cDAG_OpType type;
	unsigned int inedges;
	unsigned int outedges;
	void* buf,
	cDAG_MemType memtype,
	unsigned int count,
	unsigned int source,
	unsigned int outedges[1]
} cDAG_BinRecv;

typedef struct {
	cDAG_OpType type;
	unsigned int inedges;
	unsigned int outedges;
	char data[1];
} cDAG_BinOp;

typedef struct {
	unsigned int schedule_size;
	unsigned int scratchpad_size;
	unsigned int independent_ops;
	cDAG_BinOp ops[1];
} cDAG_BinSched;



#endif
